-- Deja Stats

local _, private = ...
	private.defaults.dvdefaults.statsSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "dvrsbframe", 
		relativePoint = "BOTTOMLEFT", 
		xOffset = 0, 
		yOffset = 0,
	}	
	
-- Information Stat Frame Parent
local statframep = CreateFrame("Frame", "StatFrameParent", dvlockcheckframe)
	statframep:RegisterEvent("PLAYER_LOGIN")
	statframep:SetFrameStrata("HIGH")
	statframep:SetClampedToScreen(true)
	statframep:SetMovable(true) 
	statframep:EnableMouse(true)
	statframep:RegisterForDrag("LeftButton")
	statframep:SetSize(160,45)
	statframep:Show()

	statframep:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local point = private.db.dvdefaults.statsSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
				point.point, 
				point.relativeTo, 
				point.relativePoint, 
				point.xOffset, 
				point.yOffset)
		end
	end)
	
	statframep:SetScript("OnDragStart", statframep.StartMoving) 
	
	statframep:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)

		private.db.dvdefaults.statsSetPoints.point = point
		private.db.dvdefaults.statsSetPoints.relativeTo = relativeTo
		private.db.dvdefaults.statsSetPoints.relativePoint = relativePoint
		private.db.dvdefaults.statsSetPoints.xOffset = xOfs
		private.db.dvdefaults.statsSetPoints.yOffset = yOfs			
	end)
	
local statframeFS = statframep:CreateFontString("FontString","OVERLAY","GameTooltipText")
local statFS = statframep:CreateFontString("FontString","OVERLAY","GameTooltipText")

	statFS:SetPoint("CENTER",statframep,"CENTER",0,0)
	statFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	statFS:SetText("Stats Frame");
	statFS:SetTextColor(1, 1, 1);
	
local tstatframe=statframep:CreateTexture(nil,"ARTWORK")
	tstatframe:SetAllPoints(statframep)
	tstatframe:SetColorTexture(0, 192, 255, 0.7)
	
-- Information Stat Frame
local statframe = CreateFrame("Frame", "StatFrame", UIParent)
	statframe:SetMovable(true) -- this and following 3 lines make window movable with mouse
	statframe:EnableMouse(true)
	statframe:RegisterForDrag("LeftButton")
	statframe:SetClampedToScreen(true)
	statframe:SetFrameStrata("MEDIUM")
	statframe:SetPoint("BOTTOM", statframep, "BOTTOM")
	statframe:SetSize(160,25)
	
	statframe:RegisterEvent("ZONE_CHANGED")
	statframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	statframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

--Gold
local goldframe = CreateFrame("Frame", nil, statframe)
	goldframe:SetFrameStrata("BACKGROUND")
	goldframe:SetWidth(50)
	goldframe:SetHeight(10)
	goldframe:SetPoint("BOTTOMRIGHT", statframe, "BOTTOMRIGHT", 0, 0)
	goldframe:Show()

	goldframe:RegisterEvent("ZONE_CHANGED")
	goldframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	goldframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local goldframeFS = goldframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local goldFS = goldframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	goldFS:SetPoint("BOTTOMRIGHT",goldframe,"BOTTOMRIGHT",0,0)
	goldFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

goldframe:SetScript("OnUpdate", function(self, e)
	elapsed = elapsed + e
		if elapsed >= 1 then
			goldRefresh()
			elapsed = 0
		end
end)

	goldframe:SetScript("OnEvent", function()
		   goldFS:SetTextColor(1, 1, 1);
		   goldRefresh()
	end)

function goldRefresh()
	local gold = GetMoney()
		if (gold>9999999) then
			goldFS:SetFormattedText("%.0fg", (gold/10000))
		end
		if (gold<10000000) then
			goldFS:SetFormattedText("%.2fg", (gold/10000))
		
		end
		if (gold<10000) then
			goldFS:SetFormattedText("%.2fs", (gold/100))
		end
		if (gold<100) then
			goldFS:SetFormattedText("%.0fc", gold)
		end
end

--Bags Remaining
local Bagframe = CreateFrame("Frame", nil, statframe)
	Bagframe:SetFrameStrata("BACKGROUND")
	Bagframe:SetWidth(50)
	Bagframe:SetHeight(10)
	Bagframe:SetPoint("BOTTOM", statframe, "BOTTOM", 0, 0)
	Bagframe:Show()

	Bagframe:RegisterEvent("ZONE_CHANGED")
	Bagframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	Bagframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local BagframeFS = Bagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local BagFS = Bagframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	BagFS:SetPoint("BOTTOM",Bagframe,"BOTTOM",0,0)
	BagFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

	Bagframe:SetScript("OnUpdate", function(self, e)
	   elapsed = elapsed + e
	   if elapsed >= 1 then
		   BagRefresh()
		   elapsed = 0
	   end
	end)

	Bagframe:SetScript("OnEvent", function()
		   BagFS:SetTextColor(1, 1, 1);
		   BagRefresh()
	end)

function BagRefresh()
	local bagRem, bagTtl = 0, 0
		for i = 0, NUM_BAG_SLOTS do
			bagRem, bagTtl = bagRem + GetContainerNumFreeSlots(i), bagTtl + GetContainerNumSlots(i)
		end

	BagFS:SetFormattedText("B:%.0f", bagRem)
end

--Durability
local duraframe = CreateFrame("Frame", nil, statframe)
	duraframe:SetFrameStrata("BACKGROUND")
	duraframe:SetWidth(50)
	duraframe:SetHeight(10)
	duraframe:SetPoint("BOTTOMLEFT", statframe, "BOTTOMLEFT", 0, 0)
	duraframe:Show()

	duraframe:RegisterEvent("ZONE_CHANGED")
	duraframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	duraframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local duraframeFS = duraframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local duraFS = duraframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	duraFS:SetPoint("BOTTOMLEFT",duraframe,"BOTTOMLEFT",0,0)
	duraFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0
	duraframe:SetScript("OnUpdate", function(self, e)
	   elapsed = elapsed + e
		   if elapsed >= 1 then
				duraRefresh()
				elapsed = 0
		   end
end)

	duraframe:SetScript("OnEvent", function()
		duraFS:SetTextColor(1, 1, 1);
		duraRefresh()
	end)

function duraRefresh()
	local durFull = true
		for slot, slotName in gmatch("1HEAD3SHOULDER5CHEST6WAIST7LEGS8FEET9WRIST10HANDS16MAINHAND17SECONDARYHAND18RANGED","(%d+)([^%d]+)") do
			local durCur, durMax = GetInventoryItemDurability(slot)
			local slotName = _G[slotName.."SLOT"]
				if ( durCur ~= durMax ) then
					duraFS:SetFormattedText("D:%.0f%%", durCur*(100/durMax))
				if ( durFull ) then 
				durFull = false 
				end
				end
		end
			
				if ( durFull ) then
					duraFS:SetText("D:100%")
				end
end

--Addon Memory
local show_mem = true
local addonframe = CreateFrame("Frame", nil, statframe)
	addonframe:SetFrameStrata("BACKGROUND")
	addonframe:SetWidth(50)
	addonframe:SetHeight(10)
	addonframe:SetPoint("TOPRIGHT", statframe, "TOPRIGHT", 0, 0)
	addonframe:Show()

	addonframe:RegisterEvent("ZONE_CHANGED")
	addonframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	addonframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local addonframeFS = addonframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local addonFS = addonframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	addonFS:SetPoint("TOPRIGHT",addonframe,"TOPRIGHT",0,0)
	addonFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

	addonframe:SetScript("OnUpdate", function(self, e)
		elapsed = elapsed + e
			if elapsed >= 1 then
				addonRefresh()
				elapsed = 0
			end
	end)

	addonframe:SetScript("OnEvent", function()
		   addonFS:SetTextColor(1, 1, 1);
		   addonRefresh()
	end)

function addonRefresh()
	if show_mem == true then
		local memory = 0
			UpdateAddOnMemoryUsage()
				for i = 1, GetNumAddOns() do
					if IsAddOnLoaded(i) then
						memory = memory + GetAddOnMemoryUsage(i)
					end
				end			
			mem = "|c00ffffff"..format("%.2f", memory / 1024).."|rMB"
	else
		mem = ""
	end
	addonFS:SetText(mem)
end

--Latency
local latencyframe = CreateFrame("Frame", nil, statframe)
	latencyframe:SetFrameStrata("BACKGROUND")
	latencyframe:SetWidth(50)
	latencyframe:SetHeight(10)
	latencyframe:SetPoint("TOP", statframe, "TOP", 0, 0)
	latencyframe:Show()

	latencyframe:RegisterEvent("ZONE_CHANGED")
	latencyframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	latencyframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local latencyframeFS = latencyframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local latencyFS = latencyframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	latencyFS:SetPoint("TOP",latencyframe,"TOP",0,0)
	latencyFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

	latencyframe:SetScript("OnUpdate", function(self, e)
		elapsed = elapsed + e
			if elapsed >= 1 then
				latencyRefresh()
				elapsed = 0
			end
	end)

	latencyframe:SetScript("OnEvent", function()
		latencyFS:SetTextColor(1, 1, 1);
		latencyRefresh()
	end)

function latencyRefresh()
	bandwidthIn, bandwidthOut, latencyHome, latencyWorld = GetNetStats()
	latencyFS:SetFormattedText("%.0fms", latencyWorld)
end

--Framerate
local fpsframe = CreateFrame("Frame", nil, statframe)
	fpsframe:SetFrameStrata("BACKGROUND")
	fpsframe:SetWidth(50)
	fpsframe:SetHeight(12)
	fpsframe:SetPoint("TOPLEFT", statframe, "TOPLEFT", 0, 0)
	fpsframe:Show()

	fpsframe:RegisterEvent("ZONE_CHANGED")
	fpsframe:RegisterEvent("ZONE_CHANGED_INDOORS")
	fpsframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")

local fpsframeFS = fpsframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	fpsframeFS:SetPoint("TOPLEFT",fpsframe,"TOPLEFT",0,0)
	fpsframeFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")

local elapsed = 0

	fpsframe:SetScript("OnUpdate", function(self, e)
		elapsed = elapsed + e
			if elapsed >= 1 then
				fpsframeRefresh()
				elapsed = 0
			end
	end)

	fpsframe:SetScript("OnEvent", function()
		fpsframeFS:SetTextColor(1, 1, 1);
		fpsframeRefresh()
	end)

function fpsframeRefresh()
	local framerate = GetFramerate()
		fpsframeFS:SetFormattedText("%.0ffps", framerate)
end